var childWin = [];
var alarmTimer;

// DOM 생성시
$(document).ready(function()
{
    init();
});

// 초기화
function init()
{
    // $.browser 생성
    $.browser = {};(function () {jQuery.browser.msie = false;$.browser.version = 0;if (navigator.userAgent.match(/MSIE ([0-9]+)\./)) {$.browser.msie = true;jQuery.browser.version = RegExp.$1;}})();

    // CSRF 토큰 등록
    $.ajaxSetup({
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        }
    });

    // 이미지가 출력되지 않을때 기본 이미지 출력
    $(document).on("error", "img", function () {
        $(this).unbind('error').attr("src", BASE_URL + "/images/default/no_image.png");
    });

    // document.body.onclick = function () { // 클릭시 초기화
    //     regLayer('admin-manage-layer-list');
    //     regLayer('admin-manage-layer-post');
    //     regLayer('admin-manage-layer-comment');
    // };

    stopAlarm();
    startAlarm();

    // 닫기 클릭 시
    $(document).on('close.bs.alert', "#infoList, #errorList, #warningList", function (e) {
        e.preventDefault();
        $(this).hide();
    });

    // IE 환경 진입시 edge 로 이동
    if (navigator.userAgent.indexOf("Trident") > 0 || /MSIE \d |Trident.*rv:/.test(navigator.userAgent)) {
        if (confirm("사용하고 계신 브라우저는 더 이상 지원하지 않습니다. 엣지 브라우저에서 확인 가능합니다.\n엣지 브라우저로 이동합니다.\n(엣지 브라우저가 켜지지 않을 경우 브라우저 설치 여부 및 설정을 확인해주세요.)") == true) {
            window.location = 'microsoft-edge:' + BASE_URL + '/login'
        }
    }
}

// Ajax 오류 처리
function procErrorEvent(xhr, status, err)
{
    let msg = "오류가 발생했습니다. 관리자에게 문의하십시오.\nError code: " + String(xhr.status) + ", message: " + err;
    alert(msg);
    console.log(msg);
    console.log(status);
    switch(xhr.status) {
        case 422:
            alert();
            break;
        case 419:
            location.reload();
            break;
    }
}

// 로그인 여부 확인
function loginCheck()
{
    if(IS_USER) {
        return true;
    }
    return $.ajax({
        url: BASE_URL + "/api/loginCheck",
        type: "GET",
        cache: false,
        async: false,
        dataType: "json",
        success: function (res) {
            if(!res) {
                if (confirm("로그인 후 이용하실 수 있습니다.\n로그인 화면으로 이동하시겠습니까?")) {
                    location.href = BASE_URL + "/login?callback=" + location.href;
                }
            }
        },
        error: function (xhr, status, err) {
            procErrorEvent(xhr, status, err);
        }
    }).responseJSON;
}

$.datepicker.setDefaults({
    inline: true,
    showMonthAfterYear: true,
    showOtherMonths: false,
    selectOtherMonths: true,
    dateFormat: 'yy-mm-dd',
    prevText: '이전 달',
    nextText: '다음 달',
    monthNames: ['1월', '2월', '3월', '4월', '5월', '6월', '7월', '8월', '9월', '10월', '11월', '12월'],
    monthNamesShort: ['1월', '2월', '3월', '4월', '5월', '6월', '7월', '8월', '9월', '10월', '11월', '12월'],
    dayNames: ['일', '월', '화', '수', '목', '금', '토'],
    dayNamesShort: ['일', '월', '화', '수', '목', '금', '토'],
    dayNamesMin: ['일', '월', '화', '수', '목', '금', '토'],
    yearSuffix: '년',
    buttonText: '선택',
    changeMonth: true,
    changeYear: true
});

// 윈도우 팝업 닫기
$(document).on("click", ".window-close", function () {
    window.close();
});

function showInfoAlarm(){
    let infoList = $("#infoList");
    if(infoList.is(":hidden")){
        infoList.show();
    }
}

function showErrorAlarm(){
    let errorList = $("#errorList");
    if(errorList.is(":hidden")){
        errorList.show();
    }
}

function showWarningAlarm(){
    let warningList = $("#warningList");
    if(warningList.is(":hidden")){
        warningList.show();
    }
}

// 알람 메시지 표시
function startAlarm(){
    alarmTimer = setInterval(function () {
        let infoList = $("#infoList");
        let errorList = $("#errorList");
        let warningList = $("#warningList");
        if (!infoList.is(":hidden")) {
            infoList.hide();
        }
        if (!errorList.is(":hidden")) {
            errorList.hide();
        }
        if (!warningList.is(":hidden")) {
            warningList.hide();
        }
    }, 30000);
}

// 알림 메시지 숨김
function stopAlarm() {
    clearInterval(alarmTimer);
}

// $('[data-toggle="popover"]').click(function (e) {
//     e.stopPropagation();
// });
//
// $(document).click(function (e) {
//     if (($('[data-toggle="popover"]').has(e.target).length == 0) || $(e.target).is('.close')) {
//         $('[data-toggle="popover"]').popover('hide');
//     }
// });

// 열린 자식 창 모두 닫기
function closeAllWindows() {
    for (let i = 0; i < childWin.length; i++) {
        if (childWin[i] && !childWin[i].closed) childWin[i].close();
    }
    window.close();
}

// 숫자 입력처리시 콤마가 입력된 상황에서 FORM SUBMIT 처리시 콤마를 강제로 제거한다.
function onlyInputUnComma(form) {
    if (form) {
        let inputs = form.getElementsByClassName("only-digits-input");
        if (inputs.length > 0) {
            for (let i in inputs) {
                if(typeof inputs[i].value == "undefined") {
                    continue;
                }
                inputs[i].value = uncomma(inputs[i].value);
            }
        }
    }
    return true;
}

// 관리 메뉴 숨김
$(document).on('mouseleave', '.admin-manage-layer', function () {
    $(this).css('display', 'none');
});

// 검색어 레이어 닫기
$(document).mouseup(function(e) {
    let search_layer = $(".header-search-keyword");
    if (search_layer.css("display") === "block") {
        if (!search_layer.is(e.target) && search_layer.has(e.target).length === 0 && e.target.name != "skeyword") {
            search_layer.hide();
            flip++;
        }
    }
    e.preventDefault();
});

// 숫자만 입력가능(콤바 기능 추가)
$(document).on("keydown keyup focusin focusout", ".only-digits-input", function (e) {
    let key;
    let event;
    switch (e.type) {
        case "focusin" :
            this.value = uncomma(this.value);
            break;
        case "focusout" :
            var number = this.value || '';
            this.value = comma(number);
            break;
        case "keyup" :
            if (window.event) {
                key = window.event.keyCode; // IE
            } else {
                key = e.which; // firefox
            }
            event = e || window.event;
            if (key == 8 || key == 46 || key == 37 || key == 39) {
                return;
            } else {
                event.target.value = event.target.value.replace(/[^0-9-]+/g, "");
            }
            break;
        case "keydown" :
            if (window.event) {
                key = window.event.keyCode; // IE
            } else {
                key = e.which; // firefox
            }
            if (key == 0 || key == 8 || key == 46 || key == 9) {
                event = e || window.event;
                if (typeof event.stopPropagation != "undefined") {
                    event.stopPropagation();
                } else {
                    event.cancelBubble = true;
                }
                return;
            }
            if (key < 48 || (key > 57 && key < 96) || (key !== 189 && key > 105) || e.shiftKey) {
                e.preventDefault ? e.preventDefault() : e.returnValue = false;
            }
            break;
    }
});

// 숫자 + 소수점 2자리까지 입력가능
$(document).on("keyup keypress", ".only-float-input", function(e) { // 키를 눌렀을 때 (한영, 한자등의 특수문자는 인식불가)
    let _value = this.value; // 공백제거
    let charCode = Number((e.which) ? e.which : e.keyCode);

    // 좌우 방향, backspace, delete, tab 는 예외
    if (charCode == 8 || charCode == 9 || charCode == 37 || charCode == 39 || charCode == 46) {
        return true;
    }

    if ((charCode > 47 && charCode < 60) || (charCode > 95 && charCode < 106) || charCode == 8 || charCode == 9 || charCode == 16 || charCode == 33 || charCode == 34
        || charCode == 35 || charCode == 36 || charCode == 37 || charCode == 38 || charCode == 39 || charCode == 40 || charCode == 46 || charCode == 144) {
        if ((charCode > 47 && charCode < 60) || (charCode > 95 && charCode < 106)) {
            if (e.shiftKey) {
                e.returnValue = false;
            }
        }
    } else {
        _value = _value.toString().replace(/[a-zA-Z]/g, ''); // 문자 제거
        _value = _value.replace(/[~!@#$%^&*()_+|<>?:{}]/g, ''); // 특수문자 제거
        _value = _value.replace(/[ㄱ-ㅎ|ㅏ-ㅣ|가-힣]/g, ''); // 한글문자 제거
        e.returnValue = false;
    }

    this.value = _value;
});

// 숫자만 입력가능
$(document).on("keydown keyup focusin focusout", ".only-number-input", function (e) {
    let key;
    let event;
    switch(e.type) {
        case "keyup" :
            if (window.event) {
                key = window.event.keyCode; // IE
            } else {
                key = e.which; // firefox
            }
            event = e || window.event;
            if (key == 8 || key == 46 || key == 37 || key == 39) {
                return;
            } else {
                event.target.value = event.target.value.replace(/[^0-9-]+/g, "");
            }
            break;
        case "keydown" :
            if (window.event) {
                key = window.event.keyCode; // IE
            } else {
                key = e.which; // firefox
            }
            if (key == 0 || key == 8 || key == 46 || key == 9) {
                event = e || window.event;
                if (typeof event.stopPropagation != "undefined") {
                    event.stopPropagation();
                } else {
                    event.cancelBubble = true;
                }
                return;
            }
            if (key < 48 || (key > 57 && key < 96) || (key !== 189 && key > 105) || e.shiftKey) {
                e.preventDefault ? e.preventDefault() : e.returnValue = false;
            }
            break;
    }
});

// 연락처 입력시 `-` 자동 입력
$(document).on("keyup", "input.only-phone-number", function () {
    let phone = this.value.trim();
    if (phone) {
        this.value = autoHypenPhone(phone);
    }
});

function redirect(link)
{
    location.replace(link);
}

// 사이트 주소 변경
function locationHref(iframe) {
    let siteUrlParam = "";
    let href = (iframe.contentWindow || iframe.contentDocument || iframe.document).location;
    if (typeof href == "undefined" || href == null) {
        href = document.location.pathname + document.location.search;
    }

    if (typeof href != "undefined" || typeof href.pathname != "undefined") {
        siteUrlParam = href.pathname + href.search;
    }

    if (siteUrlParam != 'blank') {
        location.hash = siteUrlParam;
    }

    if (typeof siteUrlParam != "undefined" && siteUrlParam != "" && siteUrlParam != "null" && siteUrlParam != '/') {
        window.location.replace("#" + encodeURIComponent(siteUrlParam)); // 메인 사이트 URL 주소 변경
        if (navigator.userAgent.indexOf("Firefox") != -1) {
            let link = document.createElement("link");
            link.type = "image/x-icon";
            link.rel = "shortcut icon";
            link.href = "/img/play-games-icon.ico";
            document.getElementsByTagName("head")[0].appendChild(link);
        }
    } else {
        window.location.replace("");
    }

    return true;
}

// 콤마 추가
function comma(str) {
    return (Math.sign(str) < 0 ? '-' : '') + String(str).replace(/(\d)(?=(?:\d{3})+(?!\d))/g, '$1,');
}

// 콤마 제거
function uncomma(str) {
    return (Math.sign(str) < 0 ? '-' : '') + String(str).replace(/[^\d]+/g, '');
}

// 글자수 검사
function checkByte(content, target, maxLength) {
    let list = [];
    let textArea = document.getElementById(content);
    if (typeof textArea == "undefined" || textArea == null) {
        list.push(Array.from(document.getElementsByName(content)));
    }

    list.push(textArea);
    let charCnt = document.getElementById(target);

    if (list.length > 0 && maxLength > 0) {
        for (let textArea of list) {
            if (typeof textArea == "object") {
                let length = (textArea.textLength || 0);
                if (length > maxLength) {
                    textArea.value = textArea.value.substr(0, maxLength);
                    length = textArea.value.length;
                }
                charCnt.innerText = length.toString();
            }
        }
    }
}

// 텍스트 복사 생성
function copyToClipboard(val) {
    try {
        let t = document.createElement("textarea");
        t.value = val;
        document.body.appendChild(t);
        t.select();
        t.setSelectionRange(0, 99999); // 모바일 브라우저(iOS)등에서 작동하도록 선택 필요!
        document.execCommand('copy');
        t.setSelectionRange(0, 0);
        document.body.removeChild(t);
        return true;
    } catch (err) {
        return false;
    }
}

// 우편번호 창
function winZip(frmName, frmZipCode, frmAddress1, frmAddress2, frmAddress3) {
    if (typeof daum === 'undefined') {
        alert('다음 juso.js 파일이 로드되지 않았습니다.');
        return false;
    }

    let completeFn = function (data) {
        // 팝업에서 검색결과 항목을 클릭했을때 실행할 코드를 작성하는 부분.

        // 각 주소의 노출 규칙에 따라 주소를 조합한다.
        // 내려오는 변수가 값이 없는 경우엔 공백('')값을 가지므로, 이를 참고하여 분기 한다.
        let fullAddr = ""; // 최종 주소 변수
        let extraAddr = ""; // 조합형 주소 변수

        // 사용자가 선택한 주소 타입에 따라 해당 주소 값을 가져온다.focus
        if (data.userSelectedType === 'R') { // 사용자가 도로명 주소를 선택했을 경우
            fullAddr = data.roadAddress;
        } else { // 사용자가 지번 주소를 선택했을 경우(J)
            fullAddr = data.jibunAddress;
        }

        // 사용자가 선택한 주소가 도로명 타입일때 참고항목을 조합한다.
        if (data.userSelectedType === 'R') {
            // 법정동명이 있을 경우 추가한다. (법정리는 제외)
            // 법정동의 경우 마지막 문자가 "동/로/가"로 끝난다.
            if (data.bname !== '' && /[동|로|가]$/g.test(data.bname)) {
                extraAddr += data.bname;
            }
            // 건물명이 있고, 공동주택일 경우 추가한다.
            if (data.buildingName !== '' && data.apartment === 'Y') {
                extraAddr += (extraAddr !== '' ? ', ' + data.buildingName : data.buildingName);
            }
            // 표시할 참고항목이 있을 경우, 괄호까지 추가한 최종 문자열을 만든다.
            if (extraAddr !== '') {
                extraAddr = ' (' + extraAddr + ')';
            }
        } else {
            extraAddr = "";
        }

        // 우편번호와 주소 정보를 해당 필드에 넣고, 커서를 상세주소 필드로 이동한다.
        let of = document[frmName];
        of[frmZipCode].value = data.zonecode;
        of[frmAddress1].value = fullAddr;
        of[frmAddress3].value = extraAddr;
        of[frmAddress2].removeAttribute('readonly');
        of[frmAddress2].focus(); // 상세주소
    };

    let rayerID = 'daum_juso_rayer' + frmZipCode;
    let elementLayer = document.getElementById(rayerID);
    if (elementLayer === null) {
        elementLayer = document.createElement('div');
        elementLayer.setAttribute('id', rayerID);
        elementLayer.style.cssText = 'display:none;border:1px solid;position:fixed;width:430px;height:460px;left:50%;margin-left:-155px;top:50%;margin-top:-235px;overflow:hidden;-webkit-overflow-scrolling:touch;z-index:10000';
        elementLayer.innerHTML = '<img src="//i1.daumcdn.net/localimg/localimages/07/postcode/320/close.png" id="btnCloseLayer" style="cursor:pointer;position:absolute;right:-3px;top:-3px;z-index:1" class="close_daum_juso" alt="닫기 버튼"/>';
        document.body.appendChild(elementLayer);
        jQuery('#' + rayerID).off('click', '.close_daum_juso').on('click', '.close_daum_juso', function (e) {
            e.preventDefault();
            jQuery(this).parent().hide();
        });
    }

    new daum.Postcode({
        oncomplete: function (data) {
            completeFn(data);

            // iframe을 넣은 element를 안보이게 한다.
            elementLayer.style.display = 'none';
        },
        width: '100%',
        height: '100%'
    }).embed(elementLayer);

    // iframe을 넣은 element를 보이게 한다.
    elementLayer.style.display = 'block';
}


// 일시정지 기능, 다.중 업로드 공격 방지
function sleep(num) {//[1/1000초]
    let now = new Date();
    let stop = now.getTime() + num;
    while (true) {
        now = new Date();
        if (now.getTime() > stop) {
            return;
        }
    }
}

// URL STRING 파라미터 가져오기
function params(name, url) {
    if (!url) {
        url = location.href;
    }
    let str = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    let regexS = "[\\?&]" + str + "=([^&#]*)";
    let regex = new RegExp(regexS);
    let results = regex.exec(url);
    return results == null ? null : results[1];
}

// 특수문자 입력은 못함
function notSpecialChar(obj) {
    let re = /[~!@\#$%^&*\()\-=+_']/gi;
    let temp = obj.value;
    if (re.test(temp)) { // 특수문자가 포함되면 삭제하여 값으로 다시셋팅
        obj.value = temp.replace(re, "");
    }
}

// 이미지 썸네일 보기
function showPreview(target, prevID, w, h) {
    let preview = document.getElementById(prevID);
    let width = (w + "px" || "100%");
    let height = (h + "px" || "100%");
    let useragent = window.navigator.userAgent;

    if (useragent.indexOf("MSIE") > -1) { // IE일때

        target.select();

        try {
            let src = document.selection.createRange().text; // get file full path
            let iePreviewError = document.getElementById("iePreviewError_" + prevID);
            if (iePreviewError) {
                preview.removeChild(iePreviewError); // error가 있으면 delete
            }
            preview.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + src + "', sizingMethod='scale')";
            // 이미지 로딩, sizingMethod는 div에 맞춰서 사이즈를 자동조절 하는 역할

        } catch (e) {
            if (!document.getElementById("iePreviewError_" + prevID)) {
                let info = document.createElement("<p>");
                info.id = "iePreviewError_" + preview;
                info.hidden = true;
                info.innerHTML = "a";
                preview.insertBefore(info, null);
            }
        }

    } else { // IE가 아닐때
        let files = target.files;
        for (let i = 0; i < files.length; i++) {
            let file = files[i];
            let imageType = /image.*/; //이미지 파일일 경우만 뿌려준다.
            if (!file.type.match(imageType)) {
                continue;
            }

            let prevImg = document.getElementById("prev_" + preview.id); // 이전에 미리보기가 있다면 삭제
            if (prevImg) {
                preview.removeChild(prevImg);
            }
            preview.innerHTML = "";

            let img = document.createElement("img"); // 크롬은 div에 이미지가 뿌려지지 않는다. 그래서 자식 Element를 만든다.
            img.id = "prev_" + preview.id;
            img.classList.add("obj");
            img.file = file;
            if (width) {
                img.style.width = width; // 기본설정된 div의 안에 뿌려지는 효과를 주기 위해서 div크기와 같은 크기를 지정해준다.
            }
            if (height) {
                img.style.height = height;
            }

            preview.appendChild(img);

            if (window.FileReader) { // FireFox, Chrome, Opera 확인.
                let reader = new FileReader();
                reader.onloadend = (function (aImg) {
                    return function (e) {
                        aImg.src = e.target.result;
                    };
                })(img);
                reader.readAsDataURL(file);
            } else { // safari is not supported FileReader
                alert("해당 브라우저 `FileReader`를 지원하지 않습니다.");
                return false;
            }
        }
    }
}

// 이미지 썸네일 삭제
function hidePreview(inputID, previewID) {
    let inputFile = document.getElementById(inputID);
    let preview = document.getElementById(previewID);

    if ($.browser.msie) { // IE 일때
        $(inputFile).replaceWith($(inputFile).clone(true));
    } else {
        $(inputFile).val("");
    }
    preview.innerHTML = ""; // 미리보기 삭제
}

// URL 파라미터 가져오기
$.urlParam = function (name) {let results = new RegExp('[\?&amp;]' + name + '=([^&amp;#]*)').exec(window.location.href);if (typeof results != "undefined" && results != "" && results != null) {return (results[1] || results[0]);} else return null;};

$.fn.textWidth = function(text, font) {if (!$.fn.textWidth.fakeEl) $.fn.textWidth.fakeEl = $('<span>').hide().appendTo(document.body);$.fn.textWidth.fakeEl.text(text || this.val() || this.text()).css('font', font || this.css('font'));return $.fn.textWidth.fakeEl.width();};

// 브라우저 조회
function getUserAgent() {return -1 !== navigator.userAgent.indexOf("MSIE") ? "IE" : -1 !== navigator.userAgent.indexOf("Firefox") ? "FF" : -1 !== navigator.userAgent.indexOf("Mozilla") ? "MZ" : -1 !== navigator.userAgent.indexOf("Opera") ? "OP" : -1 !== navigator.userAgent.indexOf("Safari") ? "SF" : -1 !== navigator.userAgent.indexOf("Mac") ? "MC" : "NG"}

// 단말기 구분
function getPlatformType() {if(navigator.userAgent.match(/mobile/i)) {return 'MOBILE';} else if (navigator.userAgent.match(/iPad|Android|Touch/i)) {return 'TABLET';} else return 'PC';}

// 숫자만 반환
function getOnlyDigit(value) {if (value) value = Number(value.replace(/[^0-9]/g, ''));return value;}

// 입력과 동시에 (,) 콤마찍기
function inputNumberFormat(obj) {if (typeof obj.value == "undefined") return false;let str = obj.value;str = String(str);str = str.replace(/[^\d]+/g, '');str = String(str);str = str.replace(/(\d)(?=(?:\d{3})+(?!\d))/g, '$1,');obj.value = str;};

// 처리중 표시
function showLoading() {document.getElementById('loading').style.display = "block";}

// 처리중 숨김
function hideLoading() {document.getElementById('loading').style.display = "none";}

// 바깥 영역 클릭시 레이어 닫기
function regLayer(target) {let obj = (document.getElementById(target) || document.getElementsByClassName(target)[0]);let e = (window.event || arguments.callee.caller.arguments[0]);let eobj = (e.target ? e.target : e.srcElement);while (eobj.parentNode) {if (eobj === obj) return false;eobj = eobj.parentNode;}closeLayer(target);};

// 열린 레이어를 닫는다.
function closeLayer(target) {let obj = (document.getElementById(target) || document.getElementsByClassName(target)[0]);if (obj) obj.style.display = 'none';}

// Tag 번호를 찾아낸다.
function getIndex(el) {let index = -1;let a = el.getAttribute("id");let b = el.getAttribute("class");let c = el.getAttribute("name");if (a) {index = Array.from(document.querySelectorAll("#" + a)).indexOf(el);} else if (b) {index = Array.from(document.querySelectorAll("." + b)).indexOf(el);} else if (c) index = Array.from(document.querySelectorAll("[name='" + c + "']")).indexOf(el);return index;}

// 이메일 유효 확인
function validateEmail(s) {return /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(s);}

// 파일 크기 반환 (byte 단위)
function uploadFileSize(file) {if (!file.value) return 0;/* 브라우저 확인*/var browser = navigator.appName;var fileSize = 0;/* 익스플로러일 경우*/if (browser === "Microsoft Internet Explorer") {fileSize = new ActiveXObject("Scripting.FileSystemObject").getFile(file.value).size;} else { /* 익스플로러가 아닐경우*/fileSize = file.files[0].size;}return fileSize;}

// 파일의 크기를 읽기 편한 크기로 변환
function formatBytes(bytes, decimals) {if (bytes === 0) return '0';var k = 1024, dm = decimals || 2, sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'], i = Math.floor(Math.log(bytes) / Math.log(k));return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + '' + sizes[i];}

// 데이터 직렬화
function makeSerializable(elem) { return $(elem).prop('elements', $('*', elem).andSelf().get()); }

// 상단으로 이동
function backToTop() {location.href = "#header";}

// 팝업창 가운데 열기
function popupCenter(url, title, w, h) {let dualScreenLeft = ((typeof window.screenLeft != "undefined") ? window.screenLeft : screen.left);let dualScreenTop = ((typeof window.screenTop != "undefined") ? window.screenTop : screen.top);let width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;let height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;let left = ((width / 2) - (w / 2)) + dualScreenLeft;let top = ((height / 2) - (h / 2)) + dualScreenTop;let newWindow = window.open(url, title, 'width=' + w + ', height=' + h + ', top=' + top + ', left=' + left + ', channelmode=0,fullscreen=0,location=0,menubar=0,scrollbars=1,toolbar=0,status=1,resizeable=0');if (newWindow != null && !newWindow.closed) newWindow.focus();return newWindow;};

// 할인가 계산
function discountPrice(price, discountType, discountValue) {if (discountType == 2) { /* 원*/return Number(price - discountValue);} else if (discountType == 1) { /* %*/discountValue = (discountValue > 100 ? 100 : discountValue);return (discountValue > 0) ? Number((price * discountValue) / 100) : price;} else return 0;}

// 전체값의 일부값은 몇 퍼센트 구하는 공식
function discountPart(total, part) {return Math.round((part / total) * 100);}

// 전체값의 몇 퍼센트 구하는 공식
function discountPer(total, per) {return Math.round((total * per) / 100);}

// 숫자를 몇 퍼센트 증가하는 공식
function discountAddPer(total, per) {return Math.round(total * (1 + per / 100));}

// 숫자를 몇 퍼센트 감소하는 공식
function discountDimPer(total, per) {return Math.round(total * (1 - per / 100));}

// 연락처 `-` 자동입력
function autoHypenPhone(str) {str = str.replace(/[^0-9]/g, '');var tmp = '';if (str.length < 4) {return str;} else if (str.length < 7) {tmp += str.substr(0, 3);tmp += '-';tmp += str.substr(3);return tmp;} else if (str.length < 11) {tmp += str.substr(0, 3);tmp += '-';tmp += str.substr(3, 3);tmp += '-';tmp += str.substr(6);return tmp;} else {tmp += str.substr(0, 3);tmp += '-';tmp += str.substr(3, 4);tmp += '-';tmp += str.substr(7);return tmp;}return str;}

// PHP array_column
function arrayColumn(matrix, col) {var column = [];for (var i = 0; i < matrix.length; i++) column.push(matrix[i][col]);return column;}

// PHP array_filter
if (!Array.prototype.filter) {Array.prototype.filter = function(fun/*, thisArg*/) {'use strict';if (this === void 0 || this === null) {throw new TypeError();}var t = Object(this);var len = t.length >>> 0;if (typeof fun !== 'function') {throw new TypeError();}var res = [];var thisArg = arguments.length >= 2 ? arguments[1] : void 0;for (var i = 0; i < len; i++) {if (i in t) {var val = t[i];if (fun.call(thisArg, val, i, t)) {res.push(val);}}}return res;};}

// URL 에서 해당 파라미터 삭제
function removeUrlParameter(url, parameter) {var urlParts = url.split('?');if (urlParts.length >= 2) {var urlBase = urlParts.shift();var queryString = urlParts.join('?');var prefix = encodeURIComponent(parameter) + '=';var parts = queryString.split(/[&;]/g);for (var i = parts.length; i-- > 0;) {if (parts[i].lastIndexOf(prefix, 0) !== -1) {parts.splice(i, 1);}}url = urlBase + '?' + parts.join('&');}return url;}

// 천단위 `,` 추가
function numberFormat(data) {if (isNaN(data) || data === null || typeof data === "undefined") {return 0;}/* 숫자 타입에서 쓸 수 있도록 format() 함수 추가*/Number.prototype.format = function () {if (this == 0) {return 0;}var reg = /(^[+-]?\d+)(\d{3})/;var n = (this + '');while (reg.test(n)) {n = n.replace(reg, '$1' + ',' + '$2');}return n;};/* 문자열 타입에서 쓸 수 있도록 format() 함수 추가*/String.prototype.format = function () {var num = parseFloat(this);if (isNaN(num)) return "0";return num.format();};return data.format();}

// 날짜 형식을 맞춰 반환 0000-00-00
function getDateFormat(date) {return date.getFullYear() + '-' + (((date.getMonth() + 1) < 10) ? '0' : '') + (date.getMonth() + 1) + '-' + ((date.getDate() < 10) ? '0' : '') + date.getDate();}

// 날짜 계산
function strtotime(sDate, v, t) {var yy = parseInt(sDate.substr(0, 4), 10);var mm = parseInt(sDate.substr(5, 2), 10);var dd = parseInt(sDate.substr(8), 10);var d;if (t == "d") {d = new Date(yy, mm - 1, dd + v);} else if (t == "m") {d = new Date(yy, mm - 1 + v, dd);} else if (t == "y") {d = new Date(yy + v, mm - 1, dd);} else {d = new Date(yy, mm - 1, dd + v);}yy = d.getFullYear();mm = d.getMonth() + 1;mm = (mm < 10) ? '0' + mm : mm;dd = d.getDate();dd = (dd < 10) ? '0' + dd : dd;return '' + yy + '-' + mm + '-' + dd;}

// 숫자와 소수점만 반환
function getRateNumber(str) {return str.replace(/[^\.0-9]/g, "");}

// 한글제거 후 반환
function delHangle(str) {var regExp = /[ㄱ-ㅎ|ㅏ-ㅣ|가-힣]/g;if (str && regExp.test(str)) {str = str.replace(regExp, "");}return str;}

// 글자길이 반환
function getByteLength(input) {var byteLength = 0;for (var inx = 0; inx < input.value.length; inx++) {var oneChar = escape(input.value.charAt(inx));if (oneChar.length == 1) {byteLength++;} else if (oneChar.indexOf("%u") != -1) {byteLength += 2;} else if (oneChar.indexOf("%") != -1) {byteLength += oneChar.length / 3;}}return byteLength;}

// 선택된 라디오버튼이 있는지 체크
function hasCheckedRadio(input) {if (input.length > 1) {for (var inx = 0; inx < input.length; inx++) {if (input[inx].checked) return true;}} else {if (input.checked) return true;}return false;}

// 선택된 체크박스가 있는지 체크
function hasCheckedBox(input) {return hasCheckedRadio(input);}

// 문자열을 find문자열을 찾아서 rps로 대체
function replaceStr(str, find, rps) {var reg = new RegExp(find, "ig");return str.replace(reg, rps);}

// 숫자를 1000단위 콤마로 구분된 문자열로 반환
function moneyFormat(num) {var comma = new RegExp("([0-9])([0-9][0-9][0-9][,.])");var data = String(num).split(".");data[0] += ".";do {data[0] = data[0].replace(comma, "$1,$2");} while (comma.test(data[0]));if (data.length > 1) return data.join(""); else return data[0].split(".")[0];}

// 1000단위 콤마로 구분된 문자열를 숫자로 반환
function moneyToNum(str) {var num = replace_str(String(str), ",", "");return Number(num);}

// 숫자 num을 n자릿수까지 반올림
function roundX(num, n) {/* 1234.675, 2 -> 1234.68*/var i = Math.pow(10, n);return Math.round(num * i) / i;}

// 숫자 num을 n자릿수까지 올림
function ceilX(num, n) {/* 1234.674, 2 -> 1234.68*/var i = Math.pow(10, n);return Math.ceil(num * i) / i;}

// 숫자 num을 n자릿수까지 내림
function floorX(num, n) {/* 1234.675, 2 -> 1234.67*/var i = Math.pow(10, n);return Math.floor(num * i) / i;}

// 공백 제거
function trim(s) {var t = '';var from_pos = 0;var to_pos = 0;for (var i = 0; i < s.length; i++) {if (s.charAt(i) === ' ') {continue;} else {from_pos = i;break;}}for (var i = s.length; i >= 0; i--) {if (s.charAt(i - 1) === ' ') {continue;} else {to_pos = i;break;}}t = s.substring(from_pos, to_pos);return t;}

// 왼쪽에 위치한 whitespace 문자를 제거
function ltrim(str) {return str.replace(/^\s+/, "");}

// 오른쪽에 위치한 whitespace 문자를 제거
function rtrim(str) {return str.replace(/\s+$/, "");}

// 주어진 문자열의 왼쪽을 padding 문자로 채운다
function lpad(str, n, padding) {if (str.length >= n) return str; else {var len = n - str.length;var pad_str = str;for (var i = 0; i < len; i++) pad_str = padding + pad_str;return pad_str;}}

// 주어진 문자열의 오른쪽을 padding 문자로 채운다
function rpad(str, n, padding) {if (str.length >= n) return str; else {var len = n - str.length;var pad_str = str;for (var i = 0; i < len; i++) {pad_str = pad_str + padding;}return pad_str;}}

// 특정문자의 개수
function countCharacter(word, ch) {var count = 0;for (var i = 0; i < word.length; i++) {if (word[i].toUpperCase() === ch.toUpperCase()) {count++;}}return count;}

// 쿠키 저장
function setCookie(name, value, options = {}) {options = {path: '/',/* 필요한 경우, 옵션 기본값을 설정할 수도 있습니다.*/ ...options};if (options.expires instanceof Date) options.expires = options.expires.toUTCString();let updatedCookie = encodeURIComponent(name) + "=" + encodeURIComponent(value);for (let optionKey in options) {updatedCookie += "; " + optionKey;let optionValue = options[optionKey];if (optionValue !== true) updatedCookie += "=" + optionValue;}document.cookie = updatedCookie;}

// 쿠키 조회
function getCookie(name) {let matches = document.cookie.match(new RegExp("(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"));return matches ? decodeURIComponent(matches[1]) : undefined;}

// 무작위 문자 생성
function generateRandomString(num) {const characters = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";let result = '';const charactersLength = characters.length;for (let i = 0; i < num; i++) result += characters.charAt(Math.floor(Math.random() * charactersLength));return result;}
